MsWksSSParser Class Reference documentation

MsWksSSParser Class Referencefinal

the main class to read a Microsoft Works spreadsheet file More...

`#include <MsWksSSParser.hxx>`

Inheritance diagram for MsWksSSParser:

## Public Member Functions
| MsWksSSParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~MsWksSSParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGSpreadsheetInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWSpreadsheetParser
| ~MWAWSpreadsheetParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGSpreadsheetInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones
bool | readSSheetZone ()
| try to read the spreadsheet data zone
void | sendNote (int id)
| try to send a note
bool | sendSpreadsheet ()
| try to send the main spreadsheet
bool | readEndHeader ()
| reads the end of the header
bool | readCell (int sz, MWAWVec2i const &cellPos, MsWksSSParserInternal::Cell &cell)
| reads a cell content data
Protected Member Functions inherited from MWAWSpreadsheetParser
| MWAWSpreadsheetParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWSpreadsheetParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< MsWksSSParserInternal::State > | m_state
| the state
std::vector< MWAWEntry > | m_listZones
| the list of different Zones
std::shared_ptr< MsWksDocument > | m_document
| the actual zone

## Friends
class | MsWksSSParserInternal::SubDocument

## Detailed Description

the main class to read a Microsoft Works spreadsheet file

## Constructor & Destructor Documentation

## ◆ MsWksSSParser()

MsWksSSParser::MsWksSSParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~MsWksSSParser()

MsWksSSParser::~MsWksSSParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool MsWksSSParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by MsWksSSParserInternal::SubDocument, and parse().

## ◆ createDocument()

void MsWksSSParser::createDocument | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by MsWksSSParserInternal::SubDocument, and parse().

## ◆ createZones()

bool MsWksSSParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by MsWksSSParserInternal::SubDocument, and parse().

## ◆ init()

void MsWksSSParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MsWksSSParser(), and MsWksSSParserInternal::SubDocument.

## ◆ parse()

void MsWksSSParser::parse | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWSpreadsheetParser.

Referenced by MsWksSSParserInternal::SubDocument.

## ◆ readCell()

bool MsWksSSParser::readCell | ( | int | sz,
|  | MWAWVec2i const & | cellPos,
|  | MsWksSSParserInternal::Cell & | cell )
| protected

reads a cell content data

Referenced by readEndHeader(), and readSSheetZone().

## ◆ readEndHeader()

bool MsWksSSParser::readEndHeader | ( |  | ) |
| protected

reads the end of the header

Referenced by readEndHeader().

## ◆ readSSheetZone()

bool MsWksSSParser::readSSheetZone | ( |  | ) |
| protected

try to read the spreadsheet data zone

Referenced by createZones(), and MsWksSSParserInternal::SubDocument.

## ◆ sendNote()

void MsWksSSParser::sendNote | ( | int | id | ) |
| protected

try to send a note

Referenced by MsWksSSParserInternal::SubDocument.

## ◆ sendSpreadsheet()

bool MsWksSSParser::sendSpreadsheet | ( |  | ) |
| protected

try to send the main spreadsheet

Referenced by MsWksSSParserInternal::SubDocument, and parse().

## Friends And Related Symbol Documentation

## ◆ MsWksSSParserInternal::SubDocument

friend class MsWksSSParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_document

std::shared_ptr<MsWksDocument> MsWksSSParser::m_document
| protected

the actual zone

Referenced by checkHeader(), createDocument(), createZones(), MsWksSSParser(), parse(), readCell(), readSSheetZone(), sendNote(), and sendSpreadsheet().

## ◆ m_listZones

std::vector<MWAWEntry> MsWksSSParser::m_listZones
| protected

the list of different Zones

Referenced by MsWksSSParser().

## ◆ m_state

std::shared_ptr<MsWksSSParserInternal::State> MsWksSSParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), MsWksSSParser(), parse(), readCell(), readSSheetZone(), sendNote(), and sendSpreadsheet().

The documentation for this class was generated from the following files:

- MsWksSSParser.hxx
- MsWksSSParser.cxx